/**  Using clipboard - needs a recent version - Chrome is OK - 
CLICK A COLOR, = COPY to Clipboard with Cb checked. */

var nColors, mousex, mousey, GG, offset = 25;
var Width = 1260, patchSize = 20, HSV = 0;
var decimalout = 6, decout = 6; // for picker
/// ^ output decimal places for POV lib vectors up to 9 or 10 - colors.js 

/* first char should not be separator for .split();
new Arrray(n), otherwise dont clutter up - use [0,0,0]; */

document.onmousedown = mouseDwn;
document.onmouseup = mouseUp;
//document.onmousemove = mRoll;
//document.onkeydown = keyDwn;

function load() {
  GG = new jsGraphics("Canvas");
  GG.setStroke(1);
  GG.setColor("#999999");
  drawpalette();
  document.getElementById("stat").value = 
       "Welcome to POV Color Picker";
newpicker();
}

function drawpalette() {
  patchSize = 19;
  nColors = 1813;
  GG.setColor("#AAAAAA");
  GG.fillRect(0,0,Width,intr(Width*.62));
  var e = document.getElementById("colorname");
  e.value = " Drawing "+nColors+" Colors";
  for (var i=0;i < nColors; i++) colorpatch(i);

  GG.paint();
  e.value = " Finished Drawing "+nColors+" Colors";
  showpicker();
  decimalout = 0;
}

function mouseDwn(e) {
  var b = e.which;
  //  if (event.button) b = event.button; IE?

  if (b == 1) {
    mousex= e.pageX; mousey= e.pageY;
    // dont know if it should be screen or page or what.
    // aint broke, dont fix it.
    mousey = mousey - offset;

if (PickerInUse && (!JC[PickerInUse].open)) PickerInUse = 0;

    var m = Math.floor(Width/patchSize);
    var i = nColors, off = 1;
    var x = (i % m) * patchSize;
    var y = Math.floor(i / m) * patchSize;
    if (mousey > (y+patchSize)) off = 1;
    else if (!PickerInUse) off = 0;
    if ((mousex > x) && (mousey > y)) off = 1;
    if (mousex > (patchSize * m)) off = 1;

    if ((!off) && (mousey > 0)) {
      // echo(" ");
      m = whichcolor();
      patchHighLight(m);
      if (HSV) bufferhue(m);
      else buffer(m);
    }
  }
  return true;
}
function mouseUp(e) {
/// mouseDwn now checks the new .open property - global pickeropen deprecated
   if (!PickerInUse) {
    // PickerInUse = 0;
    if (e.ctrlKey) send2picker(1);
    if (e.shiftKey) send2picker(2);
    if (e.altKey) send2picker(3);
    if (e.metaKey) send2picker(4); //keyup opens menu.couldnt halt it.
  }
}
function buffer(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = color[n];
  if (document.getElementById("clip").checked) clipboard("colorname");
}
function bufferhue(i) {
  var n = clamp(i, 0, nColors-1);
  document.getElementById("colorname").value = colorhue(n);
  if (document.getElementById("clip").checked) clipboard("colorname");
}
function whichcolor() {
  var m = Math.floor(Width/patchSize);
  if (mousex > (patchSize * m)) { echo("off edge"); return 0; }
  if (mousey < 0) { echo("before edge"); return 0; }

  var x = Math.floor(mousex/patchSize);
  var y = Math.floor(mousey/patchSize);
  var i = m * y + x;
  if (i >= nColors) echo("No more colors.");
  return i;
}
function send2picker(wkey) {
  var m = Math.floor(Width/patchSize);
  var x = Math.floor(mousex/patchSize);
  var y = Math.floor(mousey/patchSize);
  var i = m * y + x, v;
  i = clamp(i, 0, nColors-1);
  if (HSV) { // colorhue(i);
    var z = 320; v = 0.12 * i / z + 0.3;
    var h = 1.0 - ((i % z) / z);
    if (i < 960) v = roundv(hsv2rgb(h,1,v),6);
    else {
      v = 0.12 * (i%960) / z + 0.33;
      v = roundv(hsl2rgb(h,1,v),6);
    }
    v = RGB2Hex(multv(v,255));
  }
  else v = getpovcolor(i);
  var e = document.getElementById('col'+wkey);
  e.value = delpnd(v);
  e.style.background = v;

  var v2 = Hex2RGB(v);
  v2 = roundv(divv(v2,255),decout);
  e.style.color = 0.213*v2[0] +0.715*v2[1] +
      0.072 * v2[2] < 0.5 ? '#FFF' : '#000';
  updatestat(v);
}

/// THUMB NAIL
function colorpatch(i) {
  var sz = patchSize, c = getpovcolor(i);
  var m = Math.floor(Width/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
}
function getpovcolor(i) {
  var s = color[i], c = "#000000";
  if (s.substr(0,1) == " ") s = s.substr(1);
  var t = s.split(" ");
  if (t[3] == "White*") c = float2hex(t[4]);
  if ((t.length == 5) && (i < 9)) c = float2hex(t[4]);
  else if ((t[3] == "color") && (t[4] == "red")) c = color2hex(t[5],t[7],t[9]);
  else if ((t[3] == "color") && (t[4] == "rgb")) c = arr2hex(t[5],t[6],t[7],i);
  else if (t[3] == "rgb") c = arr2hex(t[4],t[5],t[6],i);
  return c;
}
function patchHighLight(i) {
  var sz = patchSize;
  var m = Math.floor(Width/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor("#FFFFFF");
  GG.drawRect(x,y,sz,sz);
  GG.paint();
}
function float2hex(a) {
  var b = Math.floor(parseFloat("" + a)*255.0);
  return RGB2Hex([b,b,b]);
}
function color2hex(a,b,c) {
  var c = [Math.floor(parseFloat(a)*255.0),
  Math.floor(parseFloat(b)*255.0),
  Math.floor(parseFloat(c)*255.0)];
  return RGB2Hex(c);
}

function arr2hex(a,b,c,i) {
  var d = a, e = b, f = c;
  if (a.substr(0,1) == "<") d = a.substr(1);
  var ar = [parseFloat(d),parseFloat(e),parseFloat(f)];  
  if (decimalout) {
    ar = roundv(ar,decimalout);
    var s = color[i];
    var t = s.split(" ");
    s = "<"+ar[0]+", "+ar[1]+", "+ar[2]+">;";
    if (t[4] == "rgb") color[i] = _string(t[0],t[1],t[2],t[3],t[4],s);
    if (t[3] == "rgb") color[i] = _string(t[0],t[1],t[2],t[3],s);
  }
  ar = [Math.floor(parseFloat(d)*255.0),
  Math.floor(parseFloat(e)*255.0),
  Math.floor(parseFloat(f)*255.0)];
  return RGB2Hex(ar);
}
function initcolopal(s,v) {
  // hsv sat and value initcolopal(1,.3);
  patchSize = 19; nColors = 1920; HSV = 1;
  var z = 320, sat = s, light = v;
  var i = 0, j = 0, k = 0, rgb;
  while (j < 3) {

    i = 0;
    while (i < z) {
      // sat += 0 / z;
      light += .12 / z;
      rgb = hsv2rgb(1.0 - (i / z), sat, light);
      i++;
      drwpatch(k,rgb); k++;
    }
    j++;
  }
  j = 0;
  sat = 1;
  light = .33;
  while (j < 3) {

    i = 1;
    while (i <= z) {
      // sat += 0 / z;
      light += .12 / z;
      rgb = hsl2rgb(1.0 - (i / z), sat, light);
      drwpatch(k,rgb); k++;
      i++;
      // PROGESS
      //if (((10 * i / z) % 2) == 0) e intr(100 * i / z);
    }
    j++;
  }
  GG.paint();
  document.getElementById("colorname").value = 
  " Finished Drawing "+nColors+" Colors";
  showpicker();
}

function drwpatch(i,col) {
  var sz = patchSize, c = RGB2Hex(multv(col,255));
  var m = Math.floor(Width/sz);
  var x = (i % m) * sz;
  var y = Math.floor(i / m) * sz;
  GG.setColor(c);
  GG.fillRect(x,y,sz,sz);
}
function colorhue(i) {
  var z = 320;
  var v = .3 + .12 * i / z;
  var h = 1.0 - ((i % z) / z);
  if (i < 960) return "HSV"+i + " = <"+roundv(hsv2rgb(h,1,v),6)+">;"; 
  v = .33 + .12 * (i%960) / z;
  return "HSL"+(i%960) + " = <"+roundv(hsl2rgb(h,1,v),6)+">;";
}
function initpovpal() {
  HSV = 0;
  drawpalette();
}
/// UTIL //////////////////////////
function moveLayer(e,x,y) {
  e.style.left = x+"px";
  e.style.top = y+"px";
}
function rnd(num,deci) {
  with (Math) {
    return round(num*pow(10,deci)) / pow(10,deci);
} }
function _round(num,deci) {
  with (Math) {
    return round(num*pow(10,deci)) / pow(10,deci);
} }
function roundv(v,n) {
  return [rnd(v[0],n),rnd(v[1],n),rnd(v[2],n)];
}
function clampv(v,n,m) {
  return [clamp(v[0],n,m),clamp(v[1],n,m),clamp(v[2],n,m)];
}
function addv(a,b) {
  return [a[0]+b[0],a[1]+b[1],a[2]+b[2]];
}
function divv(a,b) {
  if (!b) echo("divv divide by 0")
  else return [a[0]/b,a[1]/b,a[2]/b];
  return a;
}
function multv(a,b) {
  return [a[0]*b,a[1]*b,a[2]*b];
}
function inrect(px,py,x,y,w,h) {
  if ((px > x) && (px < (x+w))) {
    if ((py > y) && (py < (y+h))) {
      return true;
    }
  }
  return false;
}
function clamp(a,n,m) {
  if (a < n) return n;
  if (a > m) return m;
  return a;
}
function showctrl(dcp) {
  dcp.style.visibility = "visible";
}
function hidectrl(dcp) {
  dcp.style.visibility = "hidden";
}

function echoadd() {
  var dc = document;
  var arg = arguments, i = 0, s = "";
  for (var i=0;i<arg.length;i++) s = s + " " + arg[i];
  dc.getElementById("stat").value =
  dc.getElementById("stat").value + s.toString();
}
function echo() {
var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s + " " + arg[i];
  document.getElementById("stat").value = s.toString();
}

function _String() {
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s+" "+arg[i];
  return s;
}
function _string() {
  var arg = arguments, i = 0, s = "";
  for (i=0;i<arg.length;i++) s = s+arg[i]+" ";
  return s;
}
function intr(num) {
  var n = Math.floor(Math.abs(num));
  if (num < 0) n = n * -1;
  return n;
}
/// ////////////jsColor Picker//////////////
//var pickeropen = 0;

function showpicker() {
  var e = document.getElementById("picker");
  if (e.style.visibility == "hidden") showctrl(e);
  var m = Math.floor(Width/patchSize);
  var i = nColors;
  var x = (i % m) * patchSize;
  var y = Math.floor(i / m) * patchSize;
  moveLayer(e,x,y+offset);
}
function updatestat(col) {
  var e = document.getElementById("stat");
  var v = Hex2RGB(col), c = "#000000";
  var v2 = roundv(divv(v,255),decout);
  e.value='"'+col+'"'+" <"+v2+"> ["+v+"]";
  e.style.background = col;
  e.style.color = 0.213*v2[0] +0.715*v2[1] +
      0.072 * v2[2] < 0.5 ? '#FFF' : '#000';
}

function coloSet(i) {
 var e = document.getElementById("col"+i);
 updatestat('#'+e.value);
}
var PickerInUse = 0; // which Picker is being used.

function pickerid(i) {
  if ((PickerInUse != i) && PickerInUse) 
    JC[PickerInUse].hide();
  coloSet(i);
  PickerInUse = i;
  JC[i].show();
  // echo(JC[5].open); only open if open - fixed.
}

/** JC[5].open is false for other pickers-
/// ONLY IF this one was closed before opening another. 
/// global pickeropen deprecated.*/
/// <input id="col5" no class>
var JC = new Array(6); /// need a class identifier to access properties.

function newpicker() {
  JC[1] = new jscolor("col1",{width:243, height:150, mode:'HSV', 
    showOnClick:false,
    borderColor:'#FFF', insetColor:'#FFF', backgroundColor:'#666'});

  JC[2] = new jscolor("col2",{width:243, height:150, mode:'HSV', 
    showOnClick:false,
    borderColor:'#FFF', insetColor:'#FFF', backgroundColor:'#666'});
  JC[3] = new jscolor("col3",{width:243, height:150, mode:'HSV', 
    showOnClick:false,
    borderColor:'#FFF', insetColor:'#FFF', backgroundColor:'#666'});
  JC[4] = new jscolor("col4",{width:243, height:150, mode:'HSV', 
    showOnClick:false,
    borderColor:'#FFF', insetColor:'#FFF', backgroundColor:'#666'});
  JC[5] = new jscolor("col5",{width:243, height:150, mode:'HSV', 
    showOnClick:false,
    borderColor:'#FFF', insetColor:'#FFF', backgroundColor:'#666'});
// JC[5].show();
// echo(JC[5].activeClass,JC[5].width,JC[5].open);
}